/*---------------------------------------------------------------------------*\

    Copyright (C) 2000 AVM GmbH. All rights reserved.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY, without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE, and WITHOUT
    ANY LIABILITY FOR ANY DAMAGES arising out of or in connection
    with the use or performance of this software. See the
    GNU General Public License for further details.

\*---------------------------------------------------------------------------*/

#ifndef _CONVCAPI_H_
#define _CONVCAPI_H_

#include "capi2def.h"
#include "CSUnions.h"

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------*\
    Defines for ConvUnion_CallingNumber
\*---------------------------------------------------------------------------*/

#define CALLNUM_INDICATOR_DEFAULT           ((tUByte) 0x80)
#define CALLNUM_INDICATOR_SUPPRESS          ((tUByte) 0xA0)

/*---------------------------------------------------------------------------*\
    From Capi-Structs to Capi-Unions
\*---------------------------------------------------------------------------*/

tUInt ConvStruct_CalledNumber (tUChar **pTelNum, c_struct PartyNumber);

tUInt ConvStruct_CallingNumber (tUChar **pTelNum, c_struct PartyNumber);

void ConvStruct_NCPI (cu_NCPI **pCU_NCPI, c_struct CS_NCPI, c_b3prot B3Protocol);


/*---------------------------------------------------------------------------*\
    Von Capi-Unions nach Capi-Structs
\*---------------------------------------------------------------------------*/

tUInt ConvUnion_CalledNumber (c_struct *pCalledNumber, tUChar *TelNum);

tUInt ConvUnion_CallingNumber (c_struct *pCallingNumber, tUChar *TelNum,
                               tUByte Indicator = CALLNUM_INDICATOR_DEFAULT);

tUInt ConvUnion_B1Configuration (c_struct *pCS_B1Config, cu_B1Configuration *CU_B1Para, c_b1prot B1Protocol);

tUInt ConvUnion_B3Configuration (c_struct *pCS_B3Config, cu_B3Configuration *CU_B3Para, c_b3prot B3Protocol);

tUInt ConvUnion_NCPI (c_struct *pCS_NCPI, cu_NCPI *CU_NCPI, c_b3prot B3Protocol);


/*---------------------------------------------------------------------------*\
    Duplicate Structs & Strings
\*---------------------------------------------------------------------------*/

tUInt Conv_DuplicateStruct (c_struct *pDest, c_struct source);
/*----- Wenn *pDest != 0 lsche den alten Dest-Struct -----*/
/*----- return: Anzahl der kopierten Zeichen (inkl. "Lngenbytes") -----*/
/*----- Funktion ist nicht geschtzt -----*/

tUInt Conv_DuplicateString (tUChar **ppDest, tUChar *pSource);
/*----- Wenn *ppDest != 0 lsche den alten Dest-String -----*/
/*----- return: Anzahl der kopierten Zeichen (inkl. '\0') -----*/
/*----- Funktion ist nicht geschtzt -----*/


/*---------------------------------------------------------------------------*\
    Convert PLCI and NCCI
\*---------------------------------------------------------------------------*/

#define GetControllerFromPLCI(plci)     (plci & 0x0000007F)
#define GetControllerFromNCCI(ncci)     (ncci & 0x0000007F)
#define GetPLCIFromNCCI(ncci)           (ncci & 0x0000FFFF)

/*---------------------------------------------------------------------------*\
    Compare telephone numbers
\*---------------------------------------------------------------------------*/

tCompare Conv_CompareCalledPartyNumber (c_struct pNumber1, c_struct pNumber2);
tCompare Conv_CompareCallingPartyNumber (c_struct pNumber1, c_struct pNumber2);

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

#ifdef __cplusplus
}
#endif

#endif
