/*---------------------------------------------------------------------------*\

    Copyright (C) 2000 AVM GmbH. All rights reserved.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY, without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE, and WITHOUT
    ANY LIABILITY FOR ANY DAMAGES arising out of or in connection
    with the use or performance of this software. See the
    GNU General Public License for further details.

\*---------------------------------------------------------------------------*/

#ifndef _FAXRECV_H_
#define _FAXRECV_H_

#include "Channel.h"
#include "recvdev.h"
#include "sff2huf.h"
#include "huf2ftif.h"
#include "defaults.h"

/*===========================================================================*\
\*===========================================================================*/

class CFaxReceive : public CTransferChannel, public CPointerListElement {
public:
    enum ctInfo {
        i_Okay = 0,
        i_FileNotFound,
        i_FilterError
    };

    CFaxReceive (CFaxReceiveDevice *FaxRecvDevice, FaxFormatType faxtype);
    virtual ~CFaxReceive (void);

    tBool StartReceive (void);
    void StopReceive (void);

private:
    // virtual functions from CTransferChannel
    void IncomingCall (tUInt Controller, c_cipvalue CIPValue, tUChar *pOppositeNumber, tUChar *pMyCalledNumber);
    void DoConnecting (void);
    void ConnectProceeding (void);
    void IsConnected (cu_NCPI *pNCPI);
    void PutDataComplete (void *hDataID, c_info Info);
    void GetData (tUByte *Data, tUShort DataLength, tUShort DataHandle);
    void DoDisconnecting (c_info ReasonB3, cu_NCPI *pNCPI);
    void IsDisconnected (c_info Reason);
    void IsReleased (c_info Info);

    // internal functions
    struct NameList {
        NameList *next;
        tUChar    string[1];
    };

    tBool NotifyFIFO (char Type);
    void WriteLog (tSInt priority, char *text, ...);

    tBool GetJobFile (void);
    tSInt GetRecvFile (void);
    tSInt GetNextRecvFile (void);
    void DeleteRecvNames (void);

    CFaxReceiveDevice *FaxDevice;
    CSFilter_Sff2Huf   SffFilter;
    CSFilter_Huf2fTif  TifFilter;
    FaxFormatType      format;
    NameList          *RecvNames;
    tSInt              RecvFile;
    tUChar            *RecvString;
    tUChar            *ONumber;
    tUChar            *MyNumber;
    tUInt              faxFileNr;
    tUInt              jobNr;
    tUInt              NumPages;
    tUInt              VResolution;
    tUInt              BaudRate;
    tUInt              recvState;
    tUInt              quitRecv;
    time_t             StartTime;
    FILE              *hJobFile;
};

/*===========================================================================*\
\*===========================================================================*/
#endif

