/*---------------------------------------------------------------------------*\

    Copyright (C) 2000 AVM GmbH. All rights reserved.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY, without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE, and WITHOUT
    ANY LIABILITY FOR ANY DAMAGES arising out of or in connection
    with the use or performance of this software. See the
    GNU General Public License for further details.

\*---------------------------------------------------------------------------*/

#ifndef _FAXSEND_H_
#define _FAXSEND_H_

#include "Channel.h"
#include "ftif2huf.h"
#include "huf2sff.h"
#include "ConfPars.h"
#include "defaults.h"

/*===========================================================================*\
\*===========================================================================*/

class CFaxSend : public CTransferChannel {
public:
    enum ctInfo {
        i_Okay = 0,
        i_FileNotFound,
        i_FilterError,
        i_MemoryError
    };

    CFaxSend (void (*FinishedFunc)(void));
    virtual ~CFaxSend (void);
    tBool Config (char *confName, char *devName, FaxFormatType faxType, int argc, char **argv);

    ctInfo Send (tUChar *TelNumber, CConfigParserString *FaxFileNames, tUInt Resolution,
                 tUInt jobID, tUInt *pCommID);

    tUInt exitState;

private:
    // virtual functions from CTransferChannel
    void IncomingCall (tUInt Controller, c_cipvalue CIPValue, tUChar *pOppositeNumber, tUChar *pMyCalledNumber);
    void DoConnecting (void);
    void ConnectProceeding (void);
    void IsConnected (cu_NCPI *pNCPI);
    void PutDataComplete (void *hDataID, c_info Info);
    void GetData (tUByte *Data, tUShort DataLength, tUShort DataHandle);
    void DoDisconnecting (c_info ReasonB3, cu_NCPI *pNCPI);
    void IsDisconnected (c_info Reason);
    void IsReleased (c_info Info);

    void SendData (void);
    void FillSffFilter (void);
    void WriteLog (tSInt priority, char *text, ...);
    tUInt GetJobFile (void);

    CSFilter_fTif2Huf TifFilter;
    CSFilter_Huf2Sff  SffFilter;
    void (*finishFunc)(void);

    CDynamicString       FaxNumber;
    CDynamicString       Identifier;
    CDynamicString       OutMSN;
    CDynamicString       NumberPrefix;
    CDynamicString       LogFileName;
    tUInt                LogLevel;
    tUInt                LogFileMode;
    tUInt                OutController;
    tUInt                SuppressMSN;
    tUInt                UseFaxCIPValue;
    FaxFormatType        format;
    CConfigParserString *FaxFileList;
    tUInt                VResolution;
    tSInt                FaxFileD;
    FILE                *hLogFile;
    FILE                *hJobFile;
    tBool                enableEcho;
    tUInt                SendDataInUse;
    tBool                finishedFaxFile;
    tBool                UseOnlyLowRes;
};

/*===========================================================================*\
\*===========================================================================*/
#endif

