/*---------------------------------------------------------------------------*\

    Copyright (C) 2000 AVM GmbH. All rights reserved.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY, without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE, and WITHOUT
    ANY LIABILITY FOR ANY DAMAGES arising out of or in connection
    with the use or performance of this software. See the
    GNU General Public License for further details.

\*---------------------------------------------------------------------------*/

#ifndef _DBGSTACK_H_
#define _DBGSTACK_H_

#include "DbgInfo.h"

#if (USE_DEBUG_INFO_CLASS >= _USE_DEBUG_INFO_CLASS_FULL)

#include "Protect.h"

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

#define CDEBUGSTACK_MAXCOUNT   32       // mu eine 2er Potenz sein (z.B. 16, 32 od. 64)!!!!

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

class CDebugStack {
public:
    unsigned AddTo (CDebugInfo *pDbgInfo);
    void Remove (unsigned hDbgInfo);

    void ShowAllDebugOutputs (void);

    unsigned CountItems (void);

private:
    static CProtectionLock *pProtect;
    static CDebugInfo *array[CDEBUGSTACK_MAXCOUNT];
    static unsigned count;
    static unsigned root;
    static unsigned top;
};


/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

inline unsigned CDebugStack::CountItems (void) {
    return count;
}


/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

#endif

#endif
