/*---------------------------------------------------------------------------*\

    Copyright (C) 2000 AVM GmbH. All rights reserved.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY, without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE, and WITHOUT
    ANY LIABILITY FOR ANY DAMAGES arising out of or in connection
    with the use or performance of this software. See the
    GNU General Public License for further details.

\*---------------------------------------------------------------------------*/

#ifndef _osmem_h
#define _osmem_h

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/
#include "aTypes.h"

#define ISALIGNED(p)   (0==(PtrToUlong(p) & 3))

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

void*   getPtr(tUByte *m);
tULong  get64 (tUByte *m);
tUInt   get32 (tUByte *m);
tUShort get16 (tUByte *m);
tUByte  get8  (tUByte *m);

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

void setPtr (tUByte *m, void   *d);
void set64  (tUByte *m, tULong  d);
void set32  (tUByte *m, tUInt   d);
void set16  (tUByte *m, tUShort d);
void set8   (tUByte *m, tUByte  d);

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

#include <string.h>

__inline void *getPtr (tUByte *m) {
    #ifdef C_PLATFORM_64
        return (void *)get64 (m);
    #else
        return (void *)get32 (m);
    #endif
}

__inline tULong get64 (tUByte *m) {
    tULong value;
    memcpy (&value, m, sizeof (tULong));
    return value;
}

__inline tUInt get32 (tUByte *m) {
    tUInt value;
    memcpy (&value, m, sizeof (tUInt));
    return value;
}

__inline tUShort get16 (tUByte *m) {
    tUShort value;
    memcpy (&value, m, sizeof (tUShort));
    return value;
}

__inline tUByte get8 (tUByte *m) {
    return *m;
}

__inline void setPtr (tUByte *m, void *d)  {
    //assert (m != 0);
    #ifdef C_PLATFORM_64
        set64 (m, (tULong)d);
    #else
        set32 (m, (tUInt)d);
    #endif
}

__inline void set64 (tUByte *m, tULong d)  {
    //assert (m != 0);
    #if defined (OS_IS_WINDOWS_2000) || defined (OS_IS_WINDOWS_98)
        RtlStoreUlonglong (m, d);
    #else
        memcpy (m, &d, sizeof (tULong));
    #endif
}

__inline void set32 (tUByte *m, tUInt d) {
    //assert (m != 0);
    #if defined (OS_IS_WINDOWS_2000) || defined (OS_IS_WINDOWS_98) || defined (OS_IS_WINDOWS_NT) || defined (OS_IS_WINDOWS_95)
        RtlStoreUlong (m, d);
    #else
        memcpy (m, &d, sizeof (tUInt));
    #endif
}

__inline void set16 (tUByte *m, tUShort d) {
    //assert (m != 0);
    #if defined (OS_IS_WINDOWS_2000) || defined (OS_IS_WINDOWS_98) || defined (OS_IS_WINDOWS_NT) || defined (OS_IS_WINDOWS_95)
        RtlStoreUshort ((tUShort*) m, d);
    #else
        memcpy (m, &d, sizeof (tUShort));
    #endif
}

__inline void set8 (tUByte *m, tUByte d) {
    //assert (m != 0);
    *m = d;
}

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

#ifdef __cplusplus
}
#endif

#endif
